---
layout: developer-survey
title: GitLab 2018 Global Developer Report
description: Discover key trends, attitudes, and perceptions on the state of culture, workflow, and tooling within IT organizations.
twitter_image: '/images/tweets/2018-global-developer-report.png'
extra_css:
  - dev-survey-report-2018.css
extra_js:
  - libs/dev-survey-2018-bundle.js
  - dev-survey-2018.js
---

.wrapper.main-wrapper

  .section-navigation
    %ul
      %li
        %a.key-findings{ href: '#section-key-findings' }
          &nbsp;
          %span key findings
      %li
        %a.state-of-the-union{ href: '#section-state-of-the-union' }
          &nbsp;
          %span state of the union
      %li
        %a.culture{ href: '#section-culture' }
          &nbsp;
          %span culture
      %li
        %a.workflow{ href: '#section-workflow' }
          &nbsp;
          %span workflow
      %li
        %a.tools{ href: '#section-tools' }
          &nbsp;
          %span tools
      %li
        %a.demographics{ href: '#section-demographics' }
          &nbsp;
          %span demographics

  .report-section-dark
    %section.report-section.dark-bg-block.report-section-intro#section-intro

      .container
        .row
          .col-md-8
            .c-brand
              %a.c-brand-logo-wordmark{ href: "https://about.gitlab.com/"}
                = partial "includes/logos/gitlab-wordmark-rgb-white.svg"

            %h1
              2018 Global
              %br
              Developer Report

            %p.intro Software professionals collectively recognize the value of working in highly collaborative environments, and have experienced the benefits of doing so. While developers and managers are culturally aligned, workflow and tooling roadblocks delay delivery, preventing teams from reaching their maximum potential.

            %p As we look at 2018 and beyond, IT organizations that successfully adopt continuous improvement practices and seamless automation across their software development lifecycle will have happier, more collaborative, and well-functioning teams who are better positioned to meet their goals and objectives.

        .row
          .col-md-10
            %hr

    %section.report-section.dark-bg-block.report-section-key-findings#section-key-findings
      .container
        .row
          .col-md-10
            %h2 Key Findings

            .row
              .col-md-6
                %ul.c-checked-list
                  %li Managers tend to have more of an optimistic perspective on the status of their team’s overall satisfaction, productivity, and the benefits of open source tools.
                  %li While nearly all agree it’s important to work in a collaborative environment and a strong majority (81%) say it’s easy to collaborate with their team and others within their organization, visibility and transparency continues to lag with nearly half of developers (42%) reporting unclear direction as their top challenge to getting work done.
                  %li Organizations that have adopted DevOps are more likely to deploy on demand and prioritize automation than those practicing Agile.

              .col-md-6
                %ul.c-checked-list
                  %li High-performing teams have access to better tools, spend less time context-switching, and are more likely to work remotely than their lower-performing counterparts.
                  %li Overall, remote teams report higher levels of satisfaction than those working in-office, including higher levels of visibility, better insight into the deployment process, and a strong DevOps culture.
                  %li IT leaders plan to invest the most in continuous integration, delivery, and deployment in 2018, and cite selecting the right technology as their greatest challenge.

  %section.report-section.report-section-state-of-the-union#section-state-of-the-union
    .container
      %header.c-banner.u-margin-bottom-lg
        %h2 State of the Union
        %h3 Current challenges and opportunities


        %p From the junior developer with just a handful of years’ experience to the software professional who’s been in the game for decades, we set out to see how the people behind the software are dealing with a rapidly changing technology landscape.

        %p We examined overall attitudes and perceptions on the state of culture, workflow, and tooling within IT organizations with the goal to uncover any disparities between developers and IT management. We also looked at how remote versus in-office cultures are faring, compared the attitudes of agile and DevOps teams, and exposed the trends propelling high-performing teams.

        %p
          This year, we confirmed that
          %a.js-smoothscroll{ href: "#methodology" } high-performing
          teams are more likely to report having a strong DevOps culture, resulting in better visibility and collaboration than their lower-functioning counterparts. High-performing teams also report having better access to the best development tools, spend less time context switching, and are more likely to be using cloud-based tools. For leaders of high-performing teams, automating the software development lifecycle is a top priority.

      .row
        .col-md-7.col-md-offset-1
          .c-stat.alpha
            %span.number
              %span 82
              %span.percent %
            %span.label Have access to the best development tools

      .row
        .col-md-7.col-md-offset-1
          .c-stat.beta
            %span.number
              %span 60
              %span.percent %
            %span.label Report automating more of the software development lifecycle as a top priority

      .row
        .col-md-7.col-md-offset-1
          .c-stat.gamma
            %span.number
              %span 61
              %span.percent %
            %span.label Agree that developers in their organization understand how their changes affect the performance of their application(s)

      .row.u-margin-bottom-lg
        .col-md-8.col-md-offset-1
          %p We found that culturally, developers and upper management are aligned, placing high value on collaboration and communication. Managers are more optimistic about the time savings of practicing DevOps, with 81% agreeing that DevOps saves time in the development process, while only 65% of developers agree. There also appears to be a perception gap regarding how often organizations deploy code, with 47% of managers reporting that they deploy code on demand or multiple times a day, compared to only 39% of developers.

      .row.u-margin-bottom-sm
        .col-md-10.col-md-offset-1
          .row.flex-row.u-close-columns
            .col-md-4
              .c-card.alpha
                = partial 'includes/icons/manager-icon.svg'

                %h4 Top 3 2018 technology investments

                %ol
                  %li Continuous integration, deployment, and delivery
                  %li Automation and Containers
                  %li DevOps



            .col-md-4
              .c-card.beta
                = partial 'includes/icons/unified-icon.svg'

                %h4
                  Greatest
                  %br
                  challenges

                %ol
                  %li Selecting the right technology
                  %li Unclear direction
                  %li Replacing ingrained practices

            .col-md-4
              .c-card.gamma
                = partial 'includes/icons/developer-icon.svg'

                %h4
                  Top 5 most
                  %br
                  important tools

                %ol
                  %li Version control system
                  %li Text editor/IDE
                  %li Chat/collaboration tools
                  %li Bug/issue tracker
                  %li Continuous integration and delivery

      .row
        .col-md-4.col-md-offset-1
          %blockquote.c-blockquote The majority of managers say they will spend under $10,000 on technology to support their 2018 initiatives

      .row
        .col-md-7.col-md-offset-4
          .c-stat.alpha
            %span.number
              %span 22
              %span.percent %
            %span.label of upper management don’t know how much they will spend


      .u-release
        %hr.angled

      .row.u-margin-bottom-xs
        .col-md-10
          %h3 Incentives and pressures

      .row.u-margin-bottom-lg
        .col-md-8.col-md-offset-1
          %p Continuous integration emerged as the theme for 2018, with managers expecting to invest the most in CI/CD technology, and nearly half of all respondents (47%) strongly agreeing that practicing continuous integration alleviates blockers in the development process. Meanwhile selecting the right technology for the job and integration with other tools in their tech stack prove to be their biggest challenge.

      .row
        .col-md-9.col-md-offset-1
          .c-chart
            %h3.title Top 3 challenges you face using technology to support your investments for 2018

            %canvas{ id: 'chart-top-3-challenges', width: 868, height: 180 }

            .stats-notes n=684

      .row.u-margin-bottom-md
        .col-md-8.col-md-offset-1
          %p There’s an enormous incentive to implement continuous integration, delivery, and deployment. In addition to deploying on-demand, high performers experience a host of other benefits, reporting that they are more likely to feel set up to succeed, are given realistic deadlines, and are less likely to feel the need to sacrifice quality to meet a deadline. Likewise, respondents who reported using a DevOps workflow believe they are the leaders in deploying on demand and are more likely to automate more of their software development lifecycle.

      .row
        .col-md-10.col-md-offset-1
          .c-chart
            %h3.title How often do you deploy on demand?

            %canvas{ id: 'chart-deploy-on-demand', width: 730, height: 120 }

      .row
        .col-md-9.col-md-offset-1
          .c-chart
            %h3.title Automating more of the software development lifecycle is a high priority

            %canvas{ id: 'chart-sdl-high-priority', width: 720, height: 120 }

      .row.u-margin-bottom-sm
        .col-md-8.col-md-offset-1
          %p Remote teams tend to trend higher in overall satisfaction and productivity compared to in-office teams, suggesting there is an incentive to adopt a remote workplace culture.

      .row.u-margin-bottom-xs
        .col-md-4.col-md-offset-1
          .c-stat-circle.alpha
            .remote-teams-visibility.svg-container
            %span.number
              %span 67
              %span.percent %
            %p.label
              %strong of remote teams
              say they have visibility into what others are working on compared to 57% of in-office teams
        .col-md-4.col-md-offset-1
          .c-stat-circle.beta
            .in-office-ingrained-practices.svg-container
            %span.number
              %span 60
              %span.percent %
            %p.label
              %strong of in-office teams
              cite replacing ingrained practices as their number one challenge compared to 49% of remote teams

      .row
        .col-md-4.col-md-offset-1
          .c-stat-circle.gamma
            .remote-teams-devops-culture.svg-container
            %span.number
              %span 41
              %span.percent %
            %p.label
              %strong of remote teams
              agree they have a well-established DevOps culture compared to 34% of in-office teams

        .col-md-4.col-md-offset-1
          .c-stat-circle.delta
            .in-office-devops-culture.svg-container
            %span.number
              %span 40
              %span.percent %
            %p.label
              %strong of in-office teams
              disagree that their organization has a strong DevOps culture, compared to 27% of remote teams

      .u-release
        %hr.angled

      .row.u-margin-bottom-xs
        .col-md-10
          %h3 All in on open source

      .row.u-margin-bottom-lg
        .col-md-8.col-md-offset-1
          %p An emphasis on and preference for open source tools is a unifying factor across all segments. Regardless of level, culture, or workflow, open source proves to be critical for software development teams with 92% of all respondents agreeing that open source tools are important to software innovation.

      .row
        .col-md-7.col-md-offset-1
          .c-stat.alpha
            %span.number
              %span 92
              %span.percent %
            %span.label of respondents agree that open source tools are critical to software innovation

      .row
        .col-md-8.col-md-offset-1
          %p Respondents are passionate users of open source, with 75% reporting that using open source tools is important to them and 84% saying they prefer to use open source over closed or proprietary tools.

      .row
        .col-md-7.col-md-offset-4
          .c-stat.beta
            %span.number
              %span 15
              %span.percent %
            %span.label of respondents say all of their team’s development tools are open source

      .row
        .col-md-7.col-md-offset-1
          .c-stat.gamma
            %span.number
              %span 45
              %span.percent %
            %span.label of respondents say most of their team’s development tools are open source

      .row.u-margin-bottom-md
        .col-md-8.col-md-offset-1
          %p Software professionals believe that open source tools can offer multiple benefits compared to closed source software. The majority of respondents maintain that open source tools are more secure, can improve overall software quality, and streamline the development process.

      .row
        .col-md-8.col-md-offset-1
          .c-stat.alpha.large
            %span.number
              %span 60
              %span.percent %
            .label
              %h4 agree using an open source tool
              %ul
                %li improves software quality
                %li streamlines the development process
                %li is more secure

  %section.report-section.report-section-culture#section-culture
    .container
      %header.c-banner.u-margin-bottom-lg
        %h2 Culture
        %h3 Habits and behaviors that drive success

        %p
          %em The collective attitudes and behaviors of developers toward their workplace culture can offer crucial insight into effective habits and reveal crippling dysfunctions. This section serves as a benchmark for overall developer satisfaction, covering everything from physical workspaces to perceptions of success.
        %p Respondents place a strong value on working in a collaborative environment, where they feel their voices are heard and they have the ability to make decisions about their work. A strong majority suggest that they find it easy to collaborate with their team members and others in their organization. Flexible workplace and time-tracking policies are common, with productivity measured by results rather than time spent.

      .row
        .col-md-7.col-md-offset-1
          .c-stat
            %span.number
              %span 94
              %span.percent %
            %span.label of respondents said it’s important to them to work in a collaborative environment.

      .row.u-margin-bottom-md
        .col-md-8.col-md-offset-4
          .c-stat
            %span.number
              %span 81
              %span.percent %
            %span.label said they feel it is easy to collaborate with their team and others in their organization.

      .row.u-margin-bottom-sm
        .col-md-10.col-md-offset-1
          .c-chart
            %h3.title Where does your development team work
            %canvas.chart-horiz{ id: 'chart-dev-team-work', width: 684, height: 240 }

      .c-banner-small.u-margin-bottom-lg
        %h4 Analysis
        %p Remote teams, unable to rely on “facetime” around the office, have a range of ways they ensure work gets done. Twenty percent (20%) of respondents say most or all of their development team works remotely and more than half of remote development teams say they do not track time at all.

      .row
        .col-md-10.col-md-offset-1
          .c-chart.c-chart-track-time-remote
            %h3.title How do you track time for remote developers?

            %canvas{ id: 'chart-track-time-remote', width: 320, height: 530 }

            .chart-notes
              Other 4%
              %br
              Don’t know 2%

            %blockquote.c-blockquote.alpha The majority of those who work remotely do not track time.

            %blockquote.c-blockquote.beta Respondents told us they use a variety of apps, like GitLab, Pivotal Tracker, WakaTime, Toggl, Velocity by fibonacci, Bullet Journal, Time Doctor, Timular zei

      .u-release.u-margin-top-sm
        .c-image-banner.dark-bg-block.parallax{ style: "background-image: url('/images/dev-survey-2018/pull-quote-bg-1.jpg')" }
          .row
            .col-md-8.col-md-offset-1
              %q.c-quote We are goal driven so our focus is on delivery, not hours spent

          .row
            .col-md-8.col-md-offset-3
              %q.c-quote Productivity is measured by features shipped to our customers on time with high quality and reliability


      .row.u-margin-bottom-lg
        .col-md-8.col-md-offset-1
          %p Managers and developers are well aligned in a number of areas, although managers tend to be more optimistic than developers when they differ. Similar percentages (roughly 75%) of each group feel set up to succeed in their jobs, and about two-thirds agree that they are given realistic deadlines. Twenty percent of developers, and nearly the same proportion of managers, feel they are not given realistic deadlines. Only half of developers agree that project expectations and requirements are set up front, and a third say they are not.

      .row
        .col-md-7.col-md-offset-1
          .c-callout
            %strong 31%
            of developers, and
            %strong 23%
            of managers, say project expectations and requirements are not set up front.

      .row.u-margin-bottom-lg
        .col-md-8.col-md-offset-1
          %p Transparency lags behind for some teams, with a quarter of developers indicating they do not have visibility into what others, such as their colleagues in operations, product, and security, are working on. Remote or mostly remote teams lead their in-office counterparts in visibility into what others are working on, likely due to the fact that remote teammates need to be more deliberate about communication and planning in order to succeed.

          %p Although a strong majority feel comfortable proposing new ways of working, they face difficulty overcoming the status quo. Replacing ingrained practices, along with a resistance to change, are the top two challenges identified by all respondents.

      .row
        .col-md-10.col-md-offset-1
          .c-chart.c-chart-biggest-challenges
            %h3.title What are the biggest challenges your team or organization faces when it comes to adopting new practices or tools?

            %canvas{ id: 'chart-biggest-challenges', width: 868, height: 360 }

            .chart-notes
              Other 7%
              %br
              We don’t face any challenges 7%
              %br
              Don’t know 4%

      .row
        .col-md-4.col-md-offset-1
          %blockquote.c-blockquote Lower performers are more likely to identify a lack of leadership support (36%), inadequate workforce training (35%), and a risk averse culture (30%).
        .col-md-5.col-md-offset-1
          %blockquote.c-blockquote High performers are less likely to name these same challenges: 22%, 22%, and 19%, respectively.


      .row
        .col-md-10.col-md-offset-1
          %ul.compare-tabs{ role: "tablist" }
            %li.active{ role: "presentation" }
              %a{ 'data-target' => '#in-office-culture', 'data-toggle' => 'tab', 'aria-controls' => 'in-office-culture', role: 'tab' }
                = partial "includes/icons/office-icon.svg"
                in-office
            %li{ role: "presentation" }
              %a{ 'data-target' => '#remote-culture', 'data-toggle' => 'tab', 'aria-controls' => 'remote-culture', role: 'tab' }
                = partial "includes/icons/globe-icon.svg"
                remote

          .tab-content
            .tab-pane.active{ id: 'in-office-culture', role: 'tabpanel' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I have visibility into what other teams are working on", key: 'visibility-other-teams', n: '3,417' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "It’s important to me to work in a collaborative environment", key: 'collaborative-environment', n: '3,417', height: 81 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I feel comfortable proposing new practices and tools in my team or organization", key: 'new-practices', n: '3,417' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "It’s easy to collaborate with my team and others at my organization", key: 'collaborate', n: '3,417' }

            .tab-pane{ id: 'remote-culture', role: 'tabpanel' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I have visibility into what other teams are working on", key: 'visibility-other-teams-remote', n: 832 }

              .row
                .col-md-5
                  %blockquote.c-blockquote 69% of managers, compared to 57% of developers, said they have visibility into what others are working on.

                .col-md-6.col-md-offset-1
                  %blockquote.c-blockquote Lower-performing teams were less likely to report being up on what their colleagues are working on; half agreed that they have visibility into others’ work, compared to 63% of high performing teams who said the same.

              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "It’s important to me to work in a collaborative environment", key: 'collaborative-environment-remote', n: 832, height: 81 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I feel comfortable proposing new practices and tools in my team or organization", key: 'new-practices-remote', n: 832 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "It’s easy to collaborate with my team and others at my organization", key: 'collaborate-remote', n: 832 }

      .row
        .col-md-10.col-md-offset-1
          %ul.compare-tabs{ role: "tablist" }
            %li.active{ role: "presentation" }
              %a{ 'data-target' => '#lower-performing-culture', 'data-toggle' => 'tab', 'aria-controls' => 'lower-performing-culture', role: 'tab' }
                = partial "includes/icons/low-performance-icon.svg"
                lower-performing
            %li{ role: "presentation" }
              %a{ 'data-target' => '#higher-performing-culture', 'data-toggle' => 'tab', 'aria-controls' => 'higher-performing-culture', role: 'tab' }
                = partial "includes/icons/high-performance-icon.svg"
                higher-performing


          .tab-content
            .tab-pane.active{ id: 'lower-performing-culture', role: 'tabpanel' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Project expectations and requirements are set up front.", key: 'expectations-requirements', n: '3,179' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "My ideas and opinions are valued.", key: 'ideas-valued', n: '3,179' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I feel set up to succeed.", key: 'setup-to-succeed', n: 601 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I’m given realistic deadlines.", key: 'realistic-deadlines', n: 601 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I rarely need to sacrifice quality to meet a deadline.", key: 'sacrifice-quality', n: 601 }

            .tab-pane{ id: 'higher-performing-culture', role: 'tabpanel' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Project expectations and requirements are set up front.", key: 'expectations-requirements-remote', n: 737 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "My ideas and opinions are valued.", key: 'ideas-valued-remote', n: 737 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I feel set up to succeed.", key: 'setup-to-succeed-hp', n: 913 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I’m given realistic deadlines.", key: 'realistic-deadlines-hp', n: 913 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I rarely need to sacrifice quality to meet a deadline.", key: 'sacrifice-quality-hp', n: 913 }


  %section.report-section.report-section-workflow#section-workflow

    .container
      %header.c-banner
        %h2 Workflow
        %h3 How teams collaborate

        %p
          %em Process and procedure is often a hotly contested topic. Too much can hinder a team’s ability to adapt and innovate, too little can result in confusion and duplicate work. In this section, we examine the current state of balance between the two.

        %p Manual testing and a change of plans mid-process (often by non-technical stakeholders) cause headaches for developers. As one respondent summarized, “We need to plan better and automate more,” a sentiment that was echoed across multiple responses.

      .row
        .col-md-10.col-md-offset-1
          .c-chart.c-chart-testing-methodology
            %h3.title How would you describe your team’s development methodology?

            %canvas{ id: 'chart-testing-methodology', width: 868, height: 300 }

            .chart-notes
              None of the above 9%
              %br
              Don’t know 9%
              %br
              Other 4%

            %blockquote.c-blockquote.alpha A majority (67%) of all respondents agreed that using a DevOps workflow saves time during the development process; a sentiment also expressed at an even higher rate among managers, with 81% agreement.


      .row.u-margin-bottom-sm
        .col-md-4.col-md-offset-1
          %blockquote.c-blockquote.beta High-performing teams report having a clear DevOps culture at rate more than double (45%) that of lower-performing teams (21%).

        .col-md-5.col-md-offset-1
          %blockquote.c-blockquote.gamma “Chaos” was the top adjective used by respondents who chose “Other” to describe their dev process.

      .row
        .col-md-10.col-md-offset-1
          .c-chart.c-chart-challenges-to-work
            %h3.title In your opinion, what are the top challenges to getting work done?

            %canvas{ id: 'chart-challenges-to-work', width: 868, height: 180 }

            .stats-notes n=3,664

      .c-banner-small
        %h4 Analysis
        %p Respondents who told us they follow an “ad hoc” or “freeform” methodology seem content; usually these respondents elaborated to say that they work on a small team and do not find they need for a strict process. The responses from people who seem dissatisfied with an ad hoc methodology suggest that perhaps their team or company has grown large enough that they need a formalized process, but have lagged behind on implementing one.

      .row
        .col-md-10.col-md-offset-1
          .c-chart.c-chart-most-delays
            %h3.title Where in the development process do you encounter the most delays?

            %canvas{ id: 'chart-most-delays', width: 868, height: 420 }

            .chart-notes
              Other 5%
              %br
              We don’t encounter delays 4%
              %br
              Don’t know 1%

            .stats-notes n=3,281

      .row
        .col-md-4.col-md-offset-1
          %blockquote.c-blockquote.beta
            Developers said that they encountered the most delays in the
            %strong testing
            phase, whereas among management,
            %strong planning
            topped the list as the number one cause of delay.

        .col-md-5.col-md-offset-1
          %blockquote.c-blockquote.gamma 90% of managers, compared to 84% of developers, agree that practicing CI alleviates blockers in the development process.

      .u-release.u-margin-top-sm
        .c-image-banner.dark-bg-block.parallax{ style: "background-image: url('/images/dev-survey-2018/pull-quote-bg-2.jpg')" }
          .row
            .col-md-8.col-md-offset-1
              %q.c-quote Because we are not putting the investment up front into gathering business requirements and building strong product backlogs, we are running into ‘gotcha’ moments that delay the product.

          .row
            .col-md-8.col-md-offset-3
              %q.c-quote Development needs get pushed to the back burner and we have to fight to be heard. We only exist when there’s a problem, basically, and then we have to patiently explain why if you had let us resolve this six months ago when we first brought up that it was an issue, things wouldn’t be on fire right now.

      .row.u-margin-bottom-lg
        .col-md-8.col-md-offset-1
          %p Respondents show an evenly distributed range in opinions about their organizations’ use of CI. Nearly half of respondents said their organization’s use of CI is good or very good, while over one-third of respondents gave their organization’s use of CI an unfavorable rating. When we asked them to elaborate, respondents who indicated that CI is not done extensively at their organization attributed this to a lack of knowledge, skill, and habit. In a few cases, respondents indicated they had been hired expressly to set up CI and help their new team make the transition.

      .row
        .col-md-10.col-md-offset-1
          .c-chart.c-chart-ci-usage
            %h3.title How would you grade your organization’s use of CI?

            %canvas{ id: 'chart-ci-usage', width: 450, height: 530 }

            .stats-notes n=4,217

            %blockquote.c-blockquote.alpha 78% of managers, compared to 55% of developers, say that automating more of the SDLC is a top priority in their organization. 71% of respondents who practice DevOps also agreed automation is a high priority, compared to 60% of respondents who practice Agile.


      .row
        .col-md-7.col-md-offset-1
          .c-stat.alpha
            %span.number
              %span 59
              %span.percent %
            %span.label agree that developers in their organization have good insight into the deployment process

      .row
        .col-md-7.col-md-offset-4
          .c-stat.beta
            %span.number
              %span 55
              %span.percent %
            %span.label agree that developers at their organization understand how their changes affect performance

      .row
        .col-md-10.col-md-offset-1
          %ul.compare-tabs{ role: "tablist" }
            %li.active{ role: "presentation" }
              %a{ 'data-target' => '#lower-performing-workflow', 'data-toggle' => 'tab', 'aria-controls' => 'lower-performing-workflow', role: 'tab' }
                = partial "includes/icons/low-performance-icon.svg"
                lower-performing
            %li{ role: "presentation" }
              %a{ 'data-target' => '#higher-performing-workflow', 'data-toggle' => 'tab', 'aria-controls' => 'higher-performing-workflow', role: 'tab' }
                = partial "includes/icons/high-performance-icon.svg"
                higher-performing

          .tab-content
            .tab-pane.active{ id: 'lower-performing-workflow', role: 'tabpanel' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Practicing continuous integration alleviates blockers in the development process", key: 'ci-alleviates-blockers', n: 581, height: 81 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Automating more of the software development lifecycle tasks is a top priority at my organization", key: 'automate-lifecycle-tasks', n: 581 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Developers in my organization have good insight into the deployment process", key: 'deployment-process-insight', n: 581  }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Developers in my team or organization understand how their changes affect the performance of their application(s)", key: 'change-affects-performance', n: 581 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Developers in my team or organization use monitoring tools", key: 'monitoring-tools', n: 581 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Developers in my organization can automatically test their work in a live production-like environment", key: 'production-like-env', n: 581 }

            .tab-pane{ id: 'higher-performing-workflow', role: 'tabpanel' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Practicing continuous integration alleviates blockers in the development process", key: 'ci-alleviates-blockers-hp', n: 887, height: 81 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Automating more of the software development lifecycle tasks is a top priority at my organization", key: 'automate-lifecycle-tasks-hp', n: 887 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Developers in my organization have good insight into the deployment process", key: 'deployment-process-insight-hp', n: 887  }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Developers in my team or organization understand how their changes affect the performance of their application(s)", key: 'change-affects-performance-hp', n: 887 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Developers in my team or organization use monitoring tools", key: 'monitoring-tools-hp', n: 887 }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Developers in my organization can automatically test their work in a live production-like environment", key: 'production-like-env-hp', n: 887 }


      .row
        .col-md-10.col-md-offset-1
          %ul.compare-tabs{ role: "tablist" }
            %li.active{ role: "presentation" }
              %a{ 'data-target' => '#deploy-code-devops', 'data-toggle' => 'tab', 'aria-controls' => 'deploy-code-devops', role: 'tab' }
                = partial "includes/icons/devops-icon.svg"
                devops
            %li{ role: "presentation" }
              %a{ 'data-target' => '#deploy-code-agile', 'data-toggle' => 'tab', 'aria-controls' => 'deploy-code-agile', role: 'tab' }
                = partial "includes/icons/sync-icon.svg"
                agile

          .tab-content
            .tab-pane.active{ id: 'deploy-code-devops', role: 'tabpanel' }
              .c-chart
                %h3.title How often does your organization deploy code?
                %canvas{ id: 'chart-deploy-code-frequency-devops', width: 968, height: 180 }

                .chart-notes
                  Don’t know 4%
                  %br
                  Other 1%

                .stats-notes n=820

            .tab-pane{ id: 'deploy-code-agile', role: 'tabpanel' }
              .c-chart
                %h3.title How often does your organization deploy code?
                %canvas{ id: 'chart-deploy-code-frequency-agile', width: 968, height: 180 }

                .chart-notes
                  Dont’t know 3%
                  %br
                  Other 4%

                .stats-notes n=2,385

      .row
        .col-md-10.col-md-offset-1
          %ul.compare-tabs{ role: "tablist" }
            %li.active{ role: "presentation" }
              %a{ 'data-target' => '#deploy-code-developers', 'data-toggle' => 'tab', 'aria-controls' => 'deploy-code-developers', role: 'tab' }
                = partial "includes/icons/code-2-icon.svg"
                developers
            %li{ role: "presentation" }
              %a{ 'data-target' => '#deploy-code-management', 'data-toggle' => 'tab', 'aria-controls' => 'deploy-code-management', role: 'tab' }
                = partial "includes/icons/manage-icon.svg"
                management

          .tab-content
            .tab-pane.active{ id: 'deploy-code-developers', role: 'tabpanel' }
              .c-chart
                %h3.title How often does your organization deploy code?
                %canvas{ id: 'chart-deploy-code-frequency-developers', width: 968, height: 180 }

                .chart-notes
                  Don’t know 4%
                  %br
                  Other 4%

                .stats-notes n=3,123

            .tab-pane{ id: 'deploy-code-management', role: 'tabpanel' }
              .c-chart
                %h3.title How often does your organization deploy code?
                %canvas{ id: 'chart-deploy-code-frequency-management', width: 968, height: 180 }

                .chart-notes
                  Don’t know 1%
                  %br
                  Other 2%

                .stats-notes n=640

  %section.report-section.report-section-tools#section-tools

    .container
      %header.c-banner.u-margin-bottom-lg
        %h2 Tools
        %h3 The tech behind the team

        %p
          %em In a perfect world, tools help software teams work faster and automate more so they can focus on innovating and creating. However, when there’s a proliferation of options and an ever-changing technology landscape, choosing, implementing, and integrating the right tools becomes a significant challenge.

        %p  Open source wins across the board, with respondents agreeing that open source tools are preferred by developers, while also better for innovation, security, and a smooth development process.

      .row.u-margin-bottom-xl
        .col-md-10.col-md-offset-1
          .row.u-margin-bottom-sm
            .col-md-12
              %h3 Quick facts

          .row.flex-row.u-close-columns
            .col-md-3
              .c-card.prose.alpha-alt
                %p Most say they use 3 to 6 tools to complete the development process

            .col-md-3
              .c-card.prose.beta-alt
                %p One-third say they use cloud-based tools less than 19% of the time; but nearly as many (27%) say they use cloud-based tools 80-100% of the time, versus on-premise.

            .col-md-3
              .c-card.prose.gamma-alt

                %p A majority spend less than 40% of their time integrating their tools, and a plurality spend less than 19%.

            .col-md-3
              .c-card.prose.delta-alt

                %p 55% lose time context-switching between tools on a regular work day

      .c-banner-small.u-margin-bottom-lg
        %h4 Analysis
        %p There’s nearly universal agreement: developers and managers nearly all say it’s important to them to use the best available tools, and a strong majority in each group agrees that they have access to those tools. And yet, tools comprise three out of the top four concerns named by managers when asked the challenges they face supporting their investments in 2018, indicating that maintaining a sophisticated toolchain is an important challenge for software teams. Developers appear content with their tools overall; with concern over being forced to use the wrong tool for the job ranked last on their list of challenges.

      .row.u-margin-bottom-md
        .col-md-8.col-md-offset-1
          %p Managers prefer open source to closed source tools, say that using an open source tool improves software quality. Additionally, the majority of managers agree that open source tools streamline the development process and improve security at a higher rate than developers. Managers were nearly 20% more likely to say that using an open source tool is important to their development organization, suggesting perhaps that vendor lock-in is more salient for managers weighing available options.

      .row
        .col-md-10.col-md-offset-1
          .c-chart
            %h3.title Top 3 challenges you face using technology to support your investments for 2018
            %canvas{ id: 'chart-technology-support-investments', width: 684, height: 480 }
            .chart-notes
              None 6%
              %br
              Other 6%

            .stats-notes n=684

      .row
        .col-md-4.col-md-offset-1
          %blockquote.c-blockquote Engineering managers are highly concerned about the tools their teams are using.

        .col-md-5.col-md-offset-1
          %blockquote.c-blockquote Respondents who chose “Other” cited time, bandwidth, budget, scaling, and talent constraints, as well as difficulty in relationships with the business side of their organization.

      .row
        .col-md-7.col-md-offset-1
          .c-stat
            %span.number
              %span 74
              %span.percent %
            %span.label of developers agree they have access to the best development tools, and 81% of managers say the same about their team.

      .u-release.u-margin-top-sm
        .c-image-banner.dark-bg-block.parallax{ style: "background-image: url('/images/dev-survey-2018/pull-quote-bg-3.jpg')" }
          .row
            .col-md-8.col-md-offset-2
              %q.c-quote As a developer I find using open source to be critical to the overall quality of software for everyone. To rely on a paid/closed software is a risk that I don’t think it’s [sic] worth paying. Otherwise, my company still thinks that big and strong enterprise softwares are worth its costs, mainly in the infrastructure areas (operational systems and databases). We are now more open to open source because of budget limitations.

      .row.u-margin-bottom-sm
        .col-md-10.col-md-offset-1
          %ul.compare-tabs{ role: "tablist" }
            %li.active{ role: "presentation" }
              %a{ 'data-target' => '#essential-tools-agile', 'data-toggle' => 'tab', 'aria-controls' => 'essential-tools-agile', role: 'tab' }
                = partial "includes/icons/sync-icon.svg"
                agile
            %li{ role: "presentation" }
              %a{ 'data-target' => '#essential-tools-devops', 'data-toggle' => 'tab', 'aria-controls' => 'essential-tools-devops', role: 'tab' }
                = partial "includes/icons/devops-icon.svg"
                devops

          .tab-content
            .tab-pane.active{ id: 'essential-tools-agile', role: 'tabpanel' }
              %h4.tab-desc Top 3 essential tools

              .row.flex-row
                .col-md-4
                  .c-card.alpha.small-icon
                    = partial 'includes/icons/vcs-icon.svg'

                    %h4 Version Control System

                .col-md-4
                  .c-card.beta.small-icon
                    = partial 'includes/icons/ide-icon.svg'

                    %h4
                      Integrated Development Environment

                .col-md-4
                  .c-card.gamma.small-icon
                    = partial 'includes/icons/chat-icon.svg'

                    %h4
                      Chat/collaboration tool

              .row.u-margin-top-sm
                .col-md-5
                  %blockquote.c-blockquote
                    CI/CD ranked the 5th most essential tool by Agile practitioners, with half identifying it as necessary for their everyday work

            .tab-pane{ id: 'essential-tools-devops', role: 'tabpanel' }
              %h4.tab-desc Top 3 essential tools

              .row.flex-row
                .col-md-4
                  .c-card.alpha.small-icon
                    = partial 'includes/icons/vcs-icon.svg'

                    %h4 Version Control System

                .col-md-4
                  .c-card.beta.small-icon
                    = partial 'includes/icons/ide-icon.svg'

                    %h4
                      Integrated Development Environment

                .col-md-4
                  .c-card.gamma.small-icon
                    = partial 'includes/icons/ci-cd-icon.svg'

                    %h4
                      Continuous Integration/Continuous Delivery

      .row
        .col-md-10.col-md-offset-1
          %ul.compare-tabs{ role: "tablist" }
            %li.active{ role: "presentation" }
              %a{ 'data-target' => '#developers-tools', 'data-toggle' => 'tab', 'aria-controls' => 'developers-tools', role: 'tab' }
                = partial "includes/icons/code-2-icon.svg"
                developers
            %li{ role: "presentation" }
              %a{ 'data-target' => '#managers-tools', 'data-toggle' => 'tab', 'aria-controls' => 'managers-tools', role: 'tab' }
                = partial "includes/icons/manage-icon.svg"
                managers

          .tab-content
            .tab-pane.active{ id: 'developers-tools', role: 'tabpanel' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Using open source tools is important to my engineering organization.", key: 'open-source-important', n: '3,214' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Open source tools are more secure.", key: 'open-source-secure', n: '3,214' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Using an open source tool streamlines the development process.", key: 'open-source-streamlines', n: '3,214' }

            .tab-pane{ id: 'managers-tools', role: 'tabpanel' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Using open source tools is important to my engineering organization.", key: 'open-source-important-managers', n: '665' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Open source tools are more secure.", key: 'open-source-secure-managers', n: '665' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "Using an open source tool streamlines the development process.", key: 'open-source-streamlines-managers', n: '665' }


      .row
        .col-md-10.col-md-offset-1
          %ul.compare-tabs{ role: "tablist" }
            %li.active{ role: "presentation" }
              %a{ 'data-target' => '#lower-performing-tools', 'data-toggle' => 'tab', 'aria-controls' => 'lower-performing-tools', role: 'tab' }
                = partial "includes/icons/low-performance-icon.svg"
                lower-performing
            %li{ role: "presentation" }
              %a{ 'data-target' => '#higher-performing-tools', 'data-toggle' => 'tab', 'aria-controls' => 'higher-performing-tools', role: 'tab' }
                = partial "includes/icons/high-performance-icon.svg"
                higher-performing


          .tab-content
            .tab-pane.active{ id: 'lower-performing-tools', role: 'tabpanel' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I have access to the best tools.", key: 'access-to-best-tools', n: '601' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I lose time by context-switching between tools on a typical work day.", key: 'lose-time-context-switch', n: '601' }

            .tab-pane{ id: 'higher-performing-tools', role: 'tabpanel' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I have access to the best tools.", key: 'access-to-best-tools-managers', n: '913' }
              = partial "includes/dev-survey/a-n-d-chart", locals: { title: "I lose time by context-switching between tools on a typical work day.", key: 'lose-time-context-switch-managers', n: '913' }

  %section.report-section.report-section-demographics#section-demographics

    .container
      %header.c-banner.u-margin-bottom-lg
        %h2 Demographics
        %h3 Who, what, where

        %p We surveyed 5,296 software professionals from around the world. The majority of respondents identify as a software developer or engineer and work for small- to medium-sized businesses (SMB) in the hardware, services, and SaaS industries.

      .row.u-margin-bottom-xl
        .col-md-9.col-md-offset-1
          %h3.title.u-margin-bottom-sm Where are you based?

          .world-map
            %img{ alt: "", src: "/images/dev-survey-2018/world-map.jpg" }

            %ul.list-unstyled
              %li.europe
                .label Europe
                .stat 46.41%

              %li.north-america
                .label North America
                .stat 36.67%

              %li.south-america
                .label South America
                .stat 3.8%

              %li.middle-east
                .label Middle East
                .stat 1.64%

              %li.asia
                .label Asia
                .stat 6.17%

              %li.africa
                .label Africa
                .stat 1.57%

              %li.australia-and-new-zealand
                .label Australia & New Zealand
                .stat 3.38%

      .row
        .col-md-10.col-md-offset-1
          .c-chart
            %h3.title Nearly half of respondents (43.52%) are in the computer hardware/services/SaaS industry, followed by:

            %canvas{ id: 'chart-industry', width: 868, height: 420 }

      .row
        .col-md-4.col-md-offset-1
          %blockquote.c-blockquote Other industries represented by &lt;8%: government, aerospace and defense, automotive, consumer products manufacturing, energy and utilities, industrial manufacturing, biotech/pharma, insurance, food and bev

      .row
        .col-md-10.col-md-offset-1
          .c-chart
            %h3.title Majority of respondents work for SMB (how many software devs work at your org?)

            %canvas{ id: 'chart-work-for-smb', width: 868, height: 300 }

      .row
        .col-md-10.col-md-offset-1
          .c-chart
            %h3.title Majority of respondents (61.35%) identify as a software developer or engineer, followed by:

            %canvas{ id: 'chart-identify-software-developer', width: 868, height: 420 }

            .chart-notes
              Product management 1.75%
              %br
              IT management 1.69%
              %br
              QA 1.19%
              %br
              Security engineer 0.64%
              %br
              Release management 0.37%

      .row
        .col-md-10.col-md-offset-1
          .c-chart
            %h3.title Majority of software developers/engineers (61.64%) identify as a web developer, followed by:

            %canvas{ id: 'chart-identify-web-developer', width: 868, height: 420 }

      .row
        .col-md-4.col-md-offset-1
          %blockquote.c-blockquote &lt;1% identify as a machine learning specialist, graphics programming, database administrator, quality assurance engineer, graphic designer

      .row
        .col-md-10.col-md-offset-1
          .c-chart
            %h3.title Age

            %canvas{ id: 'chart-age', width: 868, height: 360 }

            .chart-notes
              51-60 1.74%
              %br
              60+ 0.45%
              %br
              prefer not to say 0.34%

      .row
        .col-md-10.col-md-offset-1
          .c-chart
            %h3.title Gender

            %canvas{ id: 'chart-gender', width: 868, height: 120 }


            .chart-notes
              non-binary/other 1.70%
              %br
              prefer not to say 1.49%

      .u-release
        %hr.angled

      .row.u-margin-top-sm
        .col-md-10
          %h2{ id: 'methodology' } Methodology

      .row.u-margin-bottom-lg
        .col-md-8.col-md-offset-1
          %p We launched this Global Developer Survey on November 17, 2017, collecting responses until December 18, 2017. During that time, we promoted the survey primarily on GitLab’s social media channels and newsletter. In order to correct for the gender imbalance developing in our survey sample, we made an extra push via Twitter on December 5 to encourage women involved in the software development lifecycle to take the survey. By the end of the open period, we achieved approximately 25% female respondents, the same percentage of women who currently hold computing roles, according to NCWIT.

      .row
        .col-md-8.col-md-offset-1
          %h3 Segmentation
          %p To create and compare the filtered views of developers and management, we used the following criteria, collected from question 8 in the survey:

      .row
        .col-md-8.col-md-offset-1
          .c-callout.c-callout--simple
            .row
              .col-md-6
                %h4 “Developer” in our survey refers to people who chose:
                %ul
                  %li Software dev/Software engineer
                  %li Software architect
                  %li Systems Engineer/Network engineer
                  %li Security engineer
                  %li Quality assurance
              .col-md-6
                %h4 “Management” in the survey will refer to:
                %ul
                  %li IT Management
                  %li Software Dev Management
                  %li DevOps Management
                  %li Technology executive
                %p.note
                  %em We excluded Product and Release management.


      .row
        .col-md-8.col-md-offset-1
          %p To create and compare the views of high-performing and lower-performing teams, we used the following criteria:

          .c-callout.c-callout--simple
            %p Higher-performing teams are defined by developers who told us that they deploy their code on demand, multiple times per day, and who estimated that they spend 50% or more of their time on new work (n=913). Lower-performing teams are defined by developers who told us that they deploy their code “between once per day and once per month” and “between once per month and once every six months.” (n=601) We took inspiration from the State of DevOps report, which identifies deployment frequency and time spent on new work versus rework as two of several indicators of high- and low-performing organizations. To ensure we had a big enough segment to compare, we lumped together everyone who does not deploy on -demand into the lower-performing category.


      .row.u-margin-bottom-md
        .col-md-8.col-md-offset-1
          %p To create and compare the views of remote and non-remote teams, we used the following criteria:

          .c-callout.c-callout--simple
            .row
              .col-md-6
                %h4 “Remote” teams:
                %ul
                  %li All of our developers work remotely
                  %li Most of our developers work remotely
              .col-md-6
                %h4 “In-office” teams:
                %ul
                  %li All of our developers work in an office
                  %li Most of our developer work in an office


      .social-sharing
        .social-sharing-item
          %a.twitter-share-button{ href: "https://twitter.com/share?ref_src=twsrc%5Etfw", 'data-text' => "See the results from @gitlab's 2018 Global Developer Survey", 'data-url' => "https://about.gitlab.com/developer-survey/2018/", 'data-show-count' => "false" }Tweet
          %script{ async: true, src: "https://platform.twitter.com/widgets.js", charset: "utf-8" }
        .social-sharing-item
          %script{ src: "//platform.linkedin.com/in.js", type: "text/javascript" } lang: en_US
          %script{ type: "IN/Share", 'data-url' => "https://about.gitlab.com/developer-survey/2018/" }

      .row.u-margin-bottom-md.u-margin-bottom-xl
        .col-md-8.col-md-offset-2
          .c-card
            %a.btn.cta-btn.purple{ href: "/pricing" } Try GitLab for Free
